/*
 * @author Choi Dae-Sung D&SOFT
 * @version 1.0, 08/03/22
 *
 * Support help@coolsms.co.kr
 *
 * methods)
 *
 * setUser	:  ̵  йȣ 
 * add		: ޼ ߰
 * send		: ޼  (IOException catch required)
 * getResult	: ۰ 
 * printResult	: ۰ 
 */
import java.util.ArrayList;
import java.net.Socket;
import java.io.*;

class CoolSMS
{
	static final String IPADDR = "210.109.102.114";
	static final int PORT = 7801;
	static final String VERSION_STR = "SSP1.0JA";
	static final int VERSION_SIZE = 8;
	static final int USERID_SIZE = 12;
	static final int PASSWD_SIZE = 12;
	static final int RCVNUM_SIZE = 11;
	static final int CALLBACK_SIZE = 11;
	static final int CALLNAME_SIZE = 10;
	static final int RESERVDATE_SIZE = 14;
	static final int MSG_SIZE = 80;
	static final int REQUEST_SIZE = 158;

	static final int RESULTCODE_SIZE = 2;
	static final int MSGID_SIZE = 26;
	static final int RESPONSE_SIZE = 36;

	private String userid;
	private String passwd;
	private ArrayList<String []> msgque;
	private ArrayList<String []> result;
	private Socket sock;

	CoolSMS() 
	{
		msgque = new ArrayList<String []>();
		result = new ArrayList<String []>();
	}


	public void setUser(String userid, String passwd) 
	{
		this.userid = userid;
		this.passwd = passwd;
	}

	/**
	 *   ޼ ߰
	 *
	 * @param callno ޴¹ȣ
	 * @param callback ȸŹȣ
	 * @param message ޼80Ʈ
	 */
	public void add(String callno, String callback, String message) 
	{
		add(callno, callback, message, "", "");
	}

	/**
	 *  ( ̸) ޼ ߰
	 *
	 * @param callno ޴¹ȣ
	 * @param callback ȸŹȣ
	 * @param message ޼80Ʈ
	 * @param callname  ̸
	 */

	public void add(String callno, String callback, String message, String callname) 
	{
		add(callno, callback, message, callname, "");
	}

	/**
	 *   ޼ ߰
	 *
	 * @param callno ޴¹ȣ
	 * @param callback ȸŹȣ
	 * @param message ޼80Ʈ
	 * @param callname  ̸
	 * @param date Ͻ YYYYMMDDHHMISS
	 */
	public void add(String callno, String callback, String message, String callname, String date) 
	{
		String[] tmsg = { callno, callback, message, callname, date };
		msgque.add(tmsg);
	}

	/**
	 * ޼  ; msgque add  ޼ Ѵ.
	 */
	public void send() throws IOException
	{
		if (userid == null || passwd == null)
		{
			System.out.println("setUser required");
			return;
		}

		sock = new Socket(IPADDR, PORT);
		BufferedOutputStream fos = new BufferedOutputStream(sock.getOutputStream());
		BufferedInputStream bis = new BufferedInputStream(sock.getInputStream());

		for (int i = 0; i < msgque.size(); i++)
		{
			String[] tmsg = msgque.get(i);
			String callno = tmsg[0];
			String callback = tmsg[1];
			String message = tmsg[2];
			String callname = tmsg[3];
			String date = tmsg[4];

			byte[] packet = assembleFields(callno, callback, message, callname, date);
			fos.write(packet, 0, REQUEST_SIZE);
			fos.flush();

			byte[] res = new byte[RESPONSE_SIZE];
			bis.read(res, 0, RESPONSE_SIZE);

			String[] resArr = decodeResult(res, callno);
			result.add(resArr);
		}

		sock.close();
	}

	public void printResult()
	{
		int succ=0;
		int fail=0;

		for (int i = 0; i < result.size(); i++)
		{
			String[] rsltSet = result.get(i);

			String callno = rsltSet[0];
			String resultcode = rsltSet[1];
			String msgid = rsltSet[2];

			if (resultcode.equals("00"))
			{
				System.out.println(callno + " was successful. Message ID=[" + msgid + "]");
				succ++;
			} else {
				System.out.println(callno + " failed. code=[" + resultcode + "]");
				fail++;
			}

			System.out.println("Total : " + (succ + fail));
			System.out.println("Success : " + succ);
			System.out.println("Failure : " + fail);
		}
	}

	public ArrayList getResult() 
	{
		return result;
	}

	private byte[] spacing(byte[] byteArr, int length)
	{
		byte[] retArr = new byte[length];
		int byteArr_size = byteArr.length;

		if (byteArr.length > length)
			byteArr_size = length;

		System.arraycopy(byteArr, 0, retArr, 0, byteArr_size);

		for (int i = byteArr_size; i < (length - byteArr_size); i++)
		{
			retArr[i] = ' ';
		}

		return retArr;
	}

	private byte[] assembleFields(String callno, String callback, String message, String callname, String date)
	{
		byte[] retArr = new byte[158];
		int pos = 0;

		System.arraycopy(spacing(VERSION_STR.getBytes(), VERSION_SIZE), 0, retArr, pos, VERSION_SIZE);
		pos += VERSION_SIZE;

		System.arraycopy(spacing(userid.getBytes(), USERID_SIZE), 0, retArr, pos, USERID_SIZE);
		pos += USERID_SIZE;

		System.arraycopy(spacing(passwd.getBytes(), PASSWD_SIZE), 0, retArr, pos, PASSWD_SIZE);
		pos += PASSWD_SIZE;

		System.arraycopy(spacing(callno.getBytes(), RCVNUM_SIZE), 0, retArr, pos, RCVNUM_SIZE);
		pos += RCVNUM_SIZE;

		System.arraycopy(spacing(callback.getBytes(), CALLBACK_SIZE), 0, retArr, pos, CALLBACK_SIZE);
		pos += CALLBACK_SIZE;

		System.arraycopy(spacing(callname.getBytes(), CALLNAME_SIZE), 0, retArr, pos, CALLNAME_SIZE);
		pos += CALLNAME_SIZE;

		System.arraycopy(spacing(date.getBytes(), RESERVDATE_SIZE), 0, retArr, pos, RESERVDATE_SIZE);
		pos += RESERVDATE_SIZE;

		System.arraycopy(spacing(message.getBytes(), MSG_SIZE), 0, retArr, pos, MSG_SIZE);
		pos += MSG_SIZE;

		return retArr;
	}

	private String[] decodeResult(byte[] res, String callno)
	{
		int pos = 0;
		byte[] resultcode = new byte[RESULTCODE_SIZE];
		byte[] msgid = new byte[MSGID_SIZE];

		pos += VERSION_SIZE;

		System.arraycopy(res, pos, resultcode, 0, RESULTCODE_SIZE);
		pos += RESULTCODE_SIZE;

		System.arraycopy(res, pos, msgid, 0, MSGID_SIZE);
		pos += MSGID_SIZE;


		String[] retArr = { callno, new String(resultcode), new String(msgid) };

		return  retArr;
	}

}
